diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lte/model/lte-ffr-distributed-algorithm.cc ns-3.47/src/lte/model/lte-ffr-distributed-algorithm.cc
--- ns-3.46/src/lte/model/lte-ffr-distributed-algorithm.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lte/model/lte-ffr-distributed-algorithm.cc	2026-02-16 16:08:49.768230400 -0800
@@ -485,9 +485,6 @@
     m_ulEdgeRbgMap.clear();
     m_ulEdgeRbgMap.resize(m_ulBandwidth, false);
 
-    Ptr<UeMeasure> servingCellMeasures;
-    Ptr<UeMeasure> neighbourCellMeasures;
-
     uint32_t edgeUeNum = 0;
     for (auto areaIt = m_ues.begin(); areaIt != m_ues.end(); areaIt++)
     {
@@ -507,29 +504,20 @@
                 continue;
             }
 
-            servingCellMeasures = nullptr;
-            neighbourCellMeasures = nullptr;
-
             auto it2 = it1->second.find(m_cellId);
-            if (it2 != it1->second.end())
-            {
-                servingCellMeasures = it2->second;
-            }
-            else
+            if (it2 == it1->second.end())
             {
                 continue;
             }
+            std::shared_ptr<UeMeasure> servingCellMeasures = it2->second;
 
             for (it2 = it1->second.begin(); it2 != it1->second.end(); it2++)
             {
-                if (it2->first != m_cellId)
-                {
-                    neighbourCellMeasures = it2->second;
-                }
-                else
+                if (it2->first == m_cellId)
                 {
                     continue;
                 }
+                std::shared_ptr<UeMeasure> neighbourCellMeasures = it2->second;
 
                 if (servingCellMeasures && neighbourCellMeasures)
                 {
@@ -695,7 +683,7 @@
     else
     {
         // insert a new cell entry
-        Ptr<UeMeasure> cellMeasures = Create<UeMeasure>();
+        auto cellMeasures = std::make_shared<UeMeasure>();
         cellMeasures->m_cellId = cellId;
         cellMeasures->m_rsrp = rsrp;
         cellMeasures->m_rsrq = rsrq;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lte/model/lte-ffr-distributed-algorithm.h ns-3.47/src/lte/model/lte-ffr-distributed-algorithm.h
--- ns-3.46/src/lte/model/lte-ffr-distributed-algorithm.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lte/model/lte-ffr-distributed-algorithm.h	2026-02-16 16:08:49.768230400 -0800
@@ -157,7 +157,7 @@
      *
      * The values are quantized according 3GPP TS 36.133 section 9.1.4 and 9.1.7.
      */
-    class UeMeasure : public SimpleRefCount<UeMeasure>
+    class UeMeasure
     {
       public:
         uint16_t m_cellId; ///< Cell ID
@@ -166,7 +166,7 @@
     };
 
     /// Cell Id is used as the key for the following map
-    typedef std::map<uint16_t, Ptr<UeMeasure>> MeasurementRow_t;
+    typedef std::map<uint16_t, std::shared_ptr<UeMeasure>> MeasurementRow_t;
     /// RNTI is used as the key for the following map
     typedef std::map<uint16_t, MeasurementRow_t> MeasurementTable_t;
     MeasurementTable_t m_ueMeasures; ///< UE measures
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lte/model/lte-mi-error-model.cc ns-3.47/src/lte/model/lte-mi-error-model.cc
--- ns-3.46/src/lte/model/lte-mi-error-model.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lte/model/lte-mi-error-model.cc	2026-02-16 16:08:49.769230600 -0800
@@ -7,7 +7,7 @@
  * Original Work Authors:
  *      Marco Mezzavilla <mezzavil@dei.unipd.it>
  *      Giovanni Tomasi <tomasigv@gmail.com>
- * Original Work Acknowldegments:
+ * Original Work Acknowledgments:
  *      This work was supported by the MEDIEVAL (MultiMEDia transport
  *      for mobIlE Video AppLications) project, which is a
  *      medium-scale focused research project (STREP) of the 7th
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lte/model/lte-rrc-header.cc ns-3.47/src/lte/model/lte-rrc-header.cc
--- ns-3.46/src/lte/model/lte-rrc-header.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lte/model/lte-rrc-header.cc	2026-02-16 16:08:49.771230500 -0800
@@ -29,7 +29,6 @@
 #define MAX_CELL_REPORT 8
 
 #define MAX_SCELL_REPORT 5
-#define MAX_SCELL_CONF 5
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lte/model/lte-spectrum-phy.cc ns-3.47/src/lte/model/lte-spectrum-phy.cc
--- ns-3.46/src/lte/model/lte-spectrum-phy.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lte/model/lte-spectrum-phy.cc	2026-02-16 16:08:49.772230600 -0800
@@ -153,6 +153,9 @@
     case LteSpectrumPhy::RX_DL_CTRL:
         os << "RX_DL_CTRL";
         break;
+    case LteSpectrumPhy::RX_UL_SRS:
+        os << "RX_UL_SRS";
+        break;
     case LteSpectrumPhy::TX_DATA:
         os << "TX_DATA";
         break;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lte/test/lte-test-carrier-aggregation-configuration.cc ns-3.47/src/lte/test/lte-test-carrier-aggregation-configuration.cc
--- ns-3.46/src/lte/test/lte-test-carrier-aggregation-configuration.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lte/test/lte-test-carrier-aggregation-configuration.cc	2026-02-16 16:08:49.776230600 -0800
@@ -343,10 +343,17 @@
         lteHelper->SetEnbDeviceAttribute("UlEarfcn", UintegerValue(configuration.m_ulEarfcn));
         lteHelper->SetUeDeviceAttribute("DlEarfcn", UintegerValue(configuration.m_dlEarfcn));
         enbDevs.Add(lteHelper->InstallEnbDevice(enbNodes.Get(i)));
-        lteHelper->AssignStreams(enbDevs, stream);
         ueDevs.Add(lteHelper->InstallUeDevice(ueNodes.Get(i)));
-        lteHelper->AssignStreams(ueDevs, stream);
     }
+    // Call AssignStreams in the EpcHelper only once by setting 'assignEpcStreams' only once
+    // Then, increment the stream value by 1000 (a magic number that should ensure that there
+    // are no overlapping stream assignments) each time that AssignStreams is called,
+    // to lessen the possibility that random variable stream assignment changes propagate
+    // to other objects.
+    lteHelper->AssignStreams(enbDevs, stream, false);
+    stream += 1000;
+    lteHelper->AssignStreams(ueDevs, stream, true);
+    stream += 1000;
 
     // Calculate the DlBandwidth, UlBandwidth, DlEarfcn and UlEarfcn to which the values from UE RRC
     // would be compared
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lte/test/lte-test-cell-selection.cc ns-3.47/src/lte/test/lte-test-cell-selection.cc
--- ns-3.46/src/lte/test/lte-test-cell-selection.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lte/test/lte-test-cell-selection.cc	2026-02-16 16:08:49.776230600 -0800
@@ -259,8 +259,15 @@
         }
     }
 
-    stream += lteHelper->AssignStreams(enbDevs, stream);
-    stream += lteHelper->AssignStreams(ueDevs, stream);
+    // Call AssignStreams in the EpcHelper only once by setting 'assignEpcStreams' only once
+    // Then, increment the stream value by 1000 (a magic number that should ensure that there
+    // are no overlapping stream assignments) each time that AssignStreams is called,
+    // to lessen the possibility that random variable stream assignment changes propagate
+    // to other objects.
+    lteHelper->AssignStreams(enbDevs, stream, false);
+    stream += 1000;
+    lteHelper->AssignStreams(ueDevs, stream, true);
+    stream += 1000;
 
     // Tests
     NS_ASSERT(m_ueSetupList.size() == ueDevs.GetN());
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lte/test/lte-test-deactivate-bearer.cc ns-3.47/src/lte/test/lte-test-deactivate-bearer.cc
--- ns-3.46/src/lte/test/lte-test-deactivate-bearer.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lte/test/lte-test-deactivate-bearer.cc	2026-02-16 16:08:49.776230600 -0800
@@ -210,10 +210,17 @@
 
     lteHelper->SetSchedulerType("ns3::PssFfMacScheduler");
     enbDevs = lteHelper->InstallEnbDevice(enbNodes);
-    stream += lteHelper->AssignStreams(enbDevs, stream);
+    // Call AssignStreams in the EpcHelper only once by setting 'assignEpcStreams' only once
+    // Then, increment the stream value by 1000 (a magic number that should ensure that there
+    // are no overlapping stream assignments) each time that AssignStreams is called,
+    // to lessen the possibility that random variable stream assignment changes propagate
+    // to other objects.
+    lteHelper->AssignStreams(enbDevs, stream, false);
+    stream += 1000;
 
     ueDevs = lteHelper->InstallUeDevice(ueNodes);
-    stream += lteHelper->AssignStreams(ueDevs, stream);
+    lteHelper->AssignStreams(ueDevs, stream, true);
+    stream += 1000;
 
     Ptr<LteEnbNetDevice> lteEnbDev = enbDevs.Get(0)->GetObject<LteEnbNetDevice>();
     Ptr<LteEnbPhy> enbPhy = lteEnbDev->GetPhy();
@@ -234,6 +241,11 @@
 
     // Install the IP stack on the UEs
     internet.Install(ueNodes);
+    internet.AssignStreams(ueNodes, stream);
+    stream += 1000;
+    internet.AssignStreams(remoteHostContainer, stream);
+    stream += 1000;
+
     Ipv4InterfaceContainer ueIpIface;
     ueIpIface = epcHelper->AssignUeIpv4Address(NetDeviceContainer(ueDevs));
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lte/test/lte-test-phy-error-model.cc ns-3.47/src/lte/test/lte-test-phy-error-model.cc
--- ns-3.46/src/lte/test/lte-test-phy-error-model.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lte/test/lte-test-phy-error-model.cc	2026-02-16 16:08:49.778230700 -0800
@@ -60,19 +60,25 @@
         //    tol = n*p - binoinv(0.001, n, p)
         // endfor
 
+        // This octave code calculates a 99.9% confidence level test (0.001 failure rate)
+        // for a binomial distribution.  'p' in this case comes from the PCFICH-PDCCH error
+        // curve in lte-mi-error-model.cc:75-91.
+        // SINR 2.0 dB corresponds to BLER of roughly 0.007, SINR 4.0 dB to BLER of 0.045
+        // SINR 6.0 dB to 0.206, and SINR 7.0 dB to 0.343.
+
         // 1 interfering eNB SINR -2.0 BLER 0.007 TB size 217
-        AddTestCase(new LenaDlCtrlPhyErrorModelTestCase(2, 1078, 0.007, 9, Seconds(0.04), rngRun),
+        AddTestCase(new LenaDlCtrlPhyErrorModelTestCase(2, 1078, 0.007, 9, rngRun),
                     (rngRun == 1) ? TestCase::Duration::QUICK : TestCase::Duration::TAKES_FOREVER);
         // 2 interfering eNBs SINR -4.0 BLER 0.037 TB size 217
-        AddTestCase(new LenaDlCtrlPhyErrorModelTestCase(3, 1040, 0.045, 21, Seconds(0.04), rngRun),
+        AddTestCase(new LenaDlCtrlPhyErrorModelTestCase(3, 1040, 0.045, 21, rngRun),
                     (rngRun == 1) ? TestCase::Duration::EXTENSIVE
                                   : TestCase::Duration::TAKES_FOREVER);
         // 3 interfering eNBs SINR -6.0 BLER 0.21 TB size 133
-        AddTestCase(new LenaDlCtrlPhyErrorModelTestCase(4, 1250, 0.206, 40, Seconds(0.12), rngRun),
+        AddTestCase(new LenaDlCtrlPhyErrorModelTestCase(4, 1250, 0.206, 40, rngRun),
                     (rngRun == 1) ? TestCase::Duration::EXTENSIVE
                                   : TestCase::Duration::TAKES_FOREVER);
         // 4 interfering eNBs SINR -7.0 BLER 0.34 TB size 133
-        AddTestCase(new LenaDlCtrlPhyErrorModelTestCase(5, 1260, 0.343, 47, Seconds(0.12), rngRun),
+        AddTestCase(new LenaDlCtrlPhyErrorModelTestCase(5, 1260, 0.343, 47, rngRun),
                     (rngRun == 1) ? TestCase::Duration::EXTENSIVE
                                   : TestCase::Duration::TAKES_FOREVER);
 
@@ -85,27 +91,27 @@
         // endfor
 
         // MCS 2 TB size of 256 bits BLER 0.33 SINR -5.51
-        AddTestCase(new LenaDataPhyErrorModelTestCase(4, 1800, 0.33, 39, Seconds(0.04), rngRun),
+        AddTestCase(new LenaDataPhyErrorModelTestCase(4, 1800, 0.33, 39, rngRun),
                     (rngRun == 1) ? TestCase::Duration::QUICK : TestCase::Duration::TAKES_FOREVER);
         // MCS 2 TB size of 528 bits BLER 0.11 SINR -5.51
-        AddTestCase(new LenaDataPhyErrorModelTestCase(2, 1800, 0.11, 26, Seconds(0.04), rngRun),
+        AddTestCase(new LenaDataPhyErrorModelTestCase(2, 1800, 0.11, 26, rngRun),
                     (rngRun == 1) ? TestCase::Duration::EXTENSIVE
                                   : TestCase::Duration::TAKES_FOREVER);
         // MCS 2 TB size of 1088 bits BLER 0.02 SINR -5.51
-        AddTestCase(new LenaDataPhyErrorModelTestCase(1, 1800, 0.02, 33, Seconds(0.04), rngRun),
+        AddTestCase(new LenaDataPhyErrorModelTestCase(1, 1800, 0.02, 33, rngRun),
                     (rngRun == 1) ? TestCase::Duration::EXTENSIVE
                                   : TestCase::Duration::TAKES_FOREVER);
         // MCS 12 TB size of 4800 bits  BLER 0.3  SINR 4.43
-        AddTestCase(new LenaDataPhyErrorModelTestCase(1, 600, 0.3, 38, Seconds(0.04), rngRun),
+        AddTestCase(new LenaDataPhyErrorModelTestCase(1, 600, 0.3, 38, rngRun),
                     (rngRun == 1) ? TestCase::Duration::EXTENSIVE
                                   : TestCase::Duration::TAKES_FOREVER);
         // MCS 12 TB size of 1632 bits  BLER 0.55  SINR 4.43
-        AddTestCase(new LenaDataPhyErrorModelTestCase(3, 600, 0.55, 40, Seconds(0.04), rngRun),
+        AddTestCase(new LenaDataPhyErrorModelTestCase(3, 600, 0.55, 40, rngRun),
                     (rngRun == 1) ? TestCase::Duration::EXTENSIVE
                                   : TestCase::Duration::TAKES_FOREVER);
         // MCS 16 TB size of 7272 bits (3648 x 3584) BLER 0.14 SINR 8.48
         // BLER 0.14 = 1 - ((1-0.075)*(1-0.075))
-        AddTestCase(new LenaDataPhyErrorModelTestCase(1, 470, 0.14, 29, Seconds(0.04), rngRun),
+        AddTestCase(new LenaDataPhyErrorModelTestCase(1, 470, 0.14, 29, rngRun),
                     (rngRun == 1) ? TestCase::Duration::EXTENSIVE
                                   : TestCase::Duration::TAKES_FOREVER);
     }
@@ -129,14 +135,12 @@
                                                              uint16_t dist,
                                                              double blerRef,
                                                              uint16_t toleranceRxPackets,
-                                                             Time statsStartTime,
                                                              uint32_t rngRun)
     : TestCase(BuildNameString(nUser, dist, rngRun)),
       m_nUser(nUser),
       m_dist(dist),
       m_blerRef(blerRef),
       m_toleranceRxPackets(toleranceRxPackets),
-      m_statsStartTime(statsStartTime),
       m_rngRun(rngRun)
 {
 }
@@ -150,6 +154,15 @@
 {
     SetDataDir(NS_TEST_SOURCEDIR);
     double ber = 0.03;
+    // Allow extra time in the beginning of simulation to allow RRC connection
+    // establishment + SRS.  The random variable (m_random in LteSpectrumPhy) can
+    // cause the MIB reception to be corrupted on the first reception attempt,
+    // leading the connection to be delayed for an extra MIB period of 80 ms.
+    // Earlier versions of this test used 40 milliseconds for low interference
+    // configurations, and 120 milliseconds for high interference configurations
+    // (4 or 5 eNBs), but 120 milliseconds was found to be too low for at least
+    // one case, so 150 ms is more conservative.
+    Time statsStartTime = MilliSeconds(150);
     Config::SetDefault("ns3::LteAmc::Ber", DoubleValue(ber));
     Config::SetDefault("ns3::LteAmc::AmcModel", EnumValue(LteAmc::PiroEW2010));
     Config::SetDefault("ns3::LteSpectrumPhy::CtrlErrorModelEnabled", BooleanValue(false));
@@ -200,14 +213,28 @@
     lena->SetSchedulerAttribute("UlCqiFilter", EnumValue(FfMacScheduler::PUSCH_UL_CQI));
 
     enbDevs = lena->InstallEnbDevice(enbNodes);
-    stream += lena->AssignStreams(enbDevs, stream);
+    // Call AssignStreams in the EpcHelper only once by setting 'assignEpcStreams' only once
+    // Then, increment the stream value by 1000 (a magic number that should ensure that there
+    // are no overlapping stream assignments) each time that AssignStreams is called,
+    // to lessen the possibility that random variable stream assignment changes propagate
+    // to other objects.
+    lena->AssignStreams(enbDevs, stream, false);
+    stream += 1000;
     ueDevs = lena->InstallUeDevice(ueNodes);
-    stream += lena->AssignStreams(ueDevs, stream);
+    lena->AssignStreams(ueDevs, stream, true);
+    stream += 1000;
+    lena->GetDownlinkSpectrumChannel()->AssignStreams(stream);
+    stream += 1000;
+    lena->GetUplinkSpectrumChannel()->AssignStreams(stream);
+    stream += 1000;
 
     // Attach a UE to a eNB
     lena->Attach(ueDevs, enbDevs.Get(0));
 
-    // Activate an EPS bearer
+    // Activate an EPS bearer.  When ActivateDataRadioBearer is called without
+    // an EPC, it defaults to the saturation mode RLC (RLC_SM_ALWAYS), which
+    // causes one packet to be generated per TTI, which provides the traffic
+    // for this test.
     EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
     EpsBearer bearer(q);
     lena->ActivateDataRadioBearer(ueDevs, bearer);
@@ -232,11 +259,11 @@
     }
 
     Time statsDuration = Seconds(1);
-    Simulator::Stop(m_statsStartTime + statsDuration - Seconds(0.0001));
+    Simulator::Stop(statsStartTime + statsDuration - Seconds(0.0001));
 
     lena->EnableRlcTraces();
     Ptr<RadioBearerStatsCalculator> rlcStats = lena->GetRlcStats();
-    rlcStats->SetAttribute("StartTime", TimeValue(m_statsStartTime));
+    rlcStats->SetAttribute("StartTime", TimeValue(statsStartTime));
     rlcStats->SetAttribute("EpochDuration", TimeValue(statsDuration));
 
     Simulator::Run();
@@ -291,14 +318,12 @@
                                                                  uint16_t dist,
                                                                  double blerRef,
                                                                  uint16_t toleranceRxPackets,
-                                                                 Time statsStartTime,
                                                                  uint32_t rngRun)
     : TestCase(BuildNameString(nEnb, dist, rngRun)),
       m_nEnb(nEnb),
       m_dist(dist),
       m_blerRef(blerRef),
       m_toleranceRxPackets(toleranceRxPackets),
-      m_statsStartTime(statsStartTime),
       m_rngRun(rngRun)
 {
 }
@@ -313,6 +338,15 @@
     SetDataDir(NS_TEST_SOURCEDIR);
 
     double ber = 0.03;
+    // Allow extra time in the beginning of simulation to allow RRC connection
+    // establishment + SRS.  The random variable (m_random in LteSpectrumPhy) can
+    // cause the MIB reception to be corrupted on the first reception attempt,
+    // leading the connection to be delayed for an extra MIB period of 80 ms.
+    // Earlier versions of this test used 40 milliseconds for low interference
+    // configurations, and 120 milliseconds for high interference configurations
+    // (4 or 5 eNBs), but 120 milliseconds was found to be too low for at least
+    // one case, so 150 ms is more conservative.
+    Time statsStartTime = MilliSeconds(150);
     Config::SetDefault("ns3::LteAmc::Ber", DoubleValue(ber));
     Config::SetDefault("ns3::LteAmc::AmcModel", EnumValue(LteAmc::PiroEW2010));
     Config::SetDefault("ns3::LteSpectrumPhy::CtrlErrorModelEnabled", BooleanValue(true));
@@ -363,14 +397,28 @@
     lena->SetSchedulerAttribute("UlCqiFilter", EnumValue(FfMacScheduler::PUSCH_UL_CQI));
 
     enbDevs = lena->InstallEnbDevice(enbNodes);
-    stream += lena->AssignStreams(enbDevs, stream);
+    // Call AssignStreams in the EpcHelper only once by setting 'assignEpcStreams' only once
+    // Then, increment the stream value by 1000 (a magic number that should ensure that there
+    // are no overlapping stream assignments) each time that AssignStreams is called,
+    // to lessen the possibility that random variable stream assignment changes propagate
+    // to other objects.
+    lena->AssignStreams(enbDevs, stream, false);
+    stream += 1000;
     ueDevs = lena->InstallUeDevice(ueNodes);
-    stream += lena->AssignStreams(ueDevs, stream);
+    lena->AssignStreams(ueDevs, stream, true);
+    stream += 1000;
+    lena->GetDownlinkSpectrumChannel()->AssignStreams(stream);
+    stream += 1000;
+    lena->GetUplinkSpectrumChannel()->AssignStreams(stream);
+    stream += 1000;
 
     // Attach a UE to one eNB (the others are interfering ones)
     lena->Attach(ueDevs, enbDevs.Get(0));
 
-    // Activate an EPS bearer
+    // Activate an EPS bearer.  When ActivateDataRadioBearer is called without
+    // an EPC, it defaults to the saturation mode RLC (RLC_SM_ALWAYS), which
+    // causes one packet to be generated per TTI, which provides the traffic
+    // for this test.
     EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
     EpsBearer bearer(q);
     lena->ActivateDataRadioBearer(ueDevs, bearer);
@@ -396,11 +444,11 @@
     uePhy->SetAttribute("NoiseFigure", DoubleValue(9.0));
 
     Time statsDuration = Seconds(1);
-    Simulator::Stop(m_statsStartTime + statsDuration - Seconds(0.0001));
+    Simulator::Stop(statsStartTime + statsDuration - Seconds(0.0001));
 
     lena->EnableRlcTraces();
     Ptr<RadioBearerStatsCalculator> rlcStats = lena->GetRlcStats();
-    rlcStats->SetAttribute("StartTime", TimeValue(m_statsStartTime));
+    rlcStats->SetAttribute("StartTime", TimeValue(statsStartTime));
     rlcStats->SetAttribute("EpochDuration", TimeValue(statsDuration));
 
     Simulator::Run();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lte/test/lte-test-phy-error-model.h ns-3.47/src/lte/test/lte-test-phy-error-model.h
--- ns-3.46/src/lte/test/lte-test-phy-error-model.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lte/test/lte-test-phy-error-model.h	2026-02-16 16:08:49.778230700 -0800
@@ -34,14 +34,12 @@
      * @param dist the distance between nodes
      * @param blerRef expected BLER
      * @param toleranceRxPackets receive packet loss tolerance
-     * @param statsStartTime the start time for collecting statistics
      * @param rngRun rng run
      */
     LenaDataPhyErrorModelTestCase(uint16_t nUser,
                                   uint16_t dist,
                                   double blerRef,
                                   uint16_t toleranceRxPackets,
-                                  Time statsStartTime,
                                   uint32_t rngRun);
     ~LenaDataPhyErrorModelTestCase() override;
 
@@ -59,9 +57,7 @@
     double m_dist;                 ///< the distance between nodes
     double m_blerRef;              ///< the expected BLER
     uint16_t m_toleranceRxPackets; ///< receive packet tolerance loss
-    Time m_statsStartTime; ///< Extra time in the beginning of simulation to allow RRC connection
-                           ///< establishment + SRS
-    uint32_t m_rngRun;     ///< the rng run
+    uint32_t m_rngRun;             ///< the rng run
 };
 
 /**
@@ -79,14 +75,12 @@
      * @param dist the distance between nodes
      * @param blerRef expected BLER
      * @param toleranceRxPackets receive packet loss tolerance
-     * @param statsStartTime the start time for collecting statistics
      * @param rngRun rng number
      */
     LenaDlCtrlPhyErrorModelTestCase(uint16_t nEnb,
                                     uint16_t dist,
                                     double blerRef,
                                     uint16_t toleranceRxPackets,
-                                    Time statsStartTime,
                                     uint32_t rngRun);
     ~LenaDlCtrlPhyErrorModelTestCase() override;
 
@@ -104,9 +98,7 @@
     double m_dist;                 ///< the distance between nodes
     double m_blerRef;              ///< the expected BLER
     uint16_t m_toleranceRxPackets; ///< receive packet tolerance loss
-    Time m_statsStartTime; ///< Extra time in the beginning of simulation to allow RRC connection
-                           ///< establishment + SRS
-    uint32_t m_rngRun;     ///< the rng run number
+    uint32_t m_rngRun;             ///< the rng run number
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lte/test/lte-test-radio-link-failure.cc ns-3.47/src/lte/test/lte-test-radio-link-failure.cc
--- ns-3.46/src/lte/test/lte-test-radio-link-failure.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lte/test/lte-test-radio-link-failure.cc	2026-02-16 16:08:49.778230700 -0800
@@ -296,10 +296,17 @@
     NetDeviceContainer ueDevs;
 
     int64_t randomStream = 1;
+    // Call AssignStreams in the EpcHelper only once by setting 'assignEpcStreams' only once
+    // Then, increment the stream value by 1000 (a magic number that should ensure that there
+    // are no overlapping stream assignments) each time that AssignStreams is called,
+    // to lessen the possibility that random variable stream assignment changes propagate
+    // to other objects.
     enbDevs = lteHelper->InstallEnbDevice(enbNodes);
-    randomStream += lteHelper->AssignStreams(enbDevs, randomStream);
+    lteHelper->AssignStreams(enbDevs, randomStream, false);
+    randomStream += 1000;
     ueDevs = lteHelper->InstallUeDevice(ueNodes);
-    randomStream += lteHelper->AssignStreams(ueDevs, randomStream);
+    lteHelper->AssignStreams(ueDevs, randomStream, true);
+    randomStream += 1000;
 
     // Install the IP stack on the UEs
     internet.Install(ueNodes);
@@ -463,7 +470,6 @@
 
     UeManager::State ueManagerState = ueManager->GetState();
     NS_TEST_ASSERT_MSG_EQ(ueManagerState, UeManager::CONNECTED_NORMALLY, "Wrong UeManager state!");
-    NS_ASSERT_MSG(ueManagerState == UeManager::CONNECTED_NORMALLY, "Wrong UeManager state!");
 
     uint16_t ueCellId = ueRrc->GetCellId();
     uint16_t enbCellId = enbLteDevice->GetCellId();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lte/test/test-lte-rrc.cc ns-3.47/src/lte/test/test-lte-rrc.cc
--- ns-3.46/src/lte/test/test-lte-rrc.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lte/test/test-lte-rrc.cc	2026-02-16 16:08:49.781230700 -0800
@@ -300,11 +300,18 @@
     int64_t stream = 1;
     NetDeviceContainer enbDevs;
     enbDevs = m_lteHelper->InstallEnbDevice(enbNodes);
-    stream += m_lteHelper->AssignStreams(enbDevs, stream);
+    // Call AssignStreams in the EpcHelper only once by setting 'assignEpcStreams' only once
+    // Then, increment the stream value by 1000 (a magic number that should ensure that there
+    // are no overlapping stream assignments) each time that AssignStreams is called,
+    // to lessen the possibility that random variable stream assignment changes propagate
+    // to other objects.
+    m_lteHelper->AssignStreams(enbDevs, stream, false);
+    stream += 1000;
 
     NetDeviceContainer ueDevs;
     ueDevs = m_lteHelper->InstallUeDevice(ueNodes);
-    stream += m_lteHelper->AssignStreams(ueDevs, stream);
+    m_lteHelper->AssignStreams(ueDevs, stream, true);
+    stream += 1000;
 
     // custom code used for testing purposes
     // instead of lteHelper->Attach () and lteHelper->ActivateXxx
@@ -658,11 +665,18 @@
     int64_t stream = 1;
     NetDeviceContainer enbDevs;
     enbDevs = m_lteHelper->InstallEnbDevice(enbNodes);
-    stream += m_lteHelper->AssignStreams(enbDevs, stream);
+    // Call AssignStreams in the EpcHelper only once by setting 'assignEpcStreams' only once
+    // Then, increment the stream value by 1000 (a magic number that should ensure that there
+    // are no overlapping stream assignments) each time that AssignStreams is called,
+    // to lessen the possibility that random variable stream assignment changes propagate
+    // to other objects.
+    m_lteHelper->AssignStreams(enbDevs, stream, false);
+    stream += 1000;
 
     NetDeviceContainer ueDevs;
     ueDevs = m_lteHelper->InstallUeDevice(ueNodes);
-    stream += m_lteHelper->AssignStreams(ueDevs, stream);
+    m_lteHelper->AssignStreams(ueDevs, stream, true);
+    stream += 1000;
 
     // custom code used for testing purposes
     // instead of lteHelper->Attach () and lteHelper->ActivateXxx
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lte/test/test-lte-x2-handover.cc ns-3.47/src/lte/test/test-lte-x2-handover.cc
--- ns-3.46/src/lte/test/test-lte-x2-handover.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lte/test/test-lte-x2-handover.cc	2026-02-16 16:08:49.781230700 -0800
@@ -264,7 +264,13 @@
 
     NetDeviceContainer enbDevices;
     enbDevices = m_lteHelper->InstallEnbDevice(enbNodes);
-    stream += m_lteHelper->AssignStreams(enbDevices, stream);
+    // Call AssignStreams in the EpcHelper only once by setting 'assignEpcStreams' only once
+    // Then, increment the stream value by 1000 (a magic number that should ensure that there
+    // are no overlapping stream assignments) each time that AssignStreams is called,
+    // to lessen the possibility that random variable stream assignment changes propagate
+    // to other objects.
+    m_lteHelper->AssignStreams(enbDevices, stream, false);
+    stream += 1000;
     for (auto it = enbDevices.Begin(); it != enbDevices.End(); ++it)
     {
         Ptr<LteEnbRrc> enbRrc = (*it)->GetObject<LteEnbNetDevice>()->GetRrc();
@@ -273,7 +279,8 @@
 
     NetDeviceContainer ueDevices;
     ueDevices = m_lteHelper->InstallUeDevice(ueNodes);
-    stream += m_lteHelper->AssignStreams(ueDevices, stream);
+    m_lteHelper->AssignStreams(ueDevices, stream, true);
+    stream += 1000;
 
     Ipv4Address remoteHostAddr;
     Ipv4StaticRoutingHelper ipv4RoutingHelper;
@@ -522,7 +529,6 @@
 
     UeManager::State ueManagerState = ueManager->GetState();
     NS_TEST_ASSERT_MSG_EQ(ueManagerState, UeManager::CONNECTED_NORMALLY, "Wrong UeManager state!");
-    NS_ASSERT_MSG(ueManagerState == UeManager::CONNECTED_NORMALLY, "Wrong UeManager state!");
 
     uint16_t ueCellId = ueRrc->GetCellId();
     uint16_t enbCellId = enbLteDevice->GetCellId();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lte/test/test-lte-x2-handover-measures.cc ns-3.47/src/lte/test/test-lte-x2-handover-measures.cc
--- ns-3.46/src/lte/test/test-lte-x2-handover-measures.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lte/test/test-lte-x2-handover-measures.cc	2026-02-16 16:08:49.781230700 -0800
@@ -334,7 +334,13 @@
 
     NetDeviceContainer enbDevices;
     enbDevices = m_lteHelper->InstallEnbDevice(enbNodes);
-    stream += m_lteHelper->AssignStreams(enbDevices, stream);
+    // Call AssignStreams in the EpcHelper only once by setting 'assignEpcStreams' only once
+    // Then, increment the stream value by 1000 (a magic number that should ensure that there
+    // are no overlapping stream assignments) each time that AssignStreams is called,
+    // to lessen the possibility that random variable stream assignment changes propagate
+    // to other objects.
+    m_lteHelper->AssignStreams(enbDevices, stream, false);
+    stream += 1000;
     for (auto it = enbDevices.Begin(); it != enbDevices.End(); ++it)
     {
         Ptr<LteEnbRrc> enbRrc = (*it)->GetObject<LteEnbNetDevice>()->GetRrc();
@@ -343,7 +349,8 @@
 
     NetDeviceContainer ueDevices;
     ueDevices = m_lteHelper->InstallUeDevice(ueNodes);
-    stream += m_lteHelper->AssignStreams(ueDevices, stream);
+    m_lteHelper->AssignStreams(ueDevices, stream, true);
+    stream += 1000;
 
     Ipv4Address remoteHostAddr;
     Ipv4StaticRoutingHelper ipv4RoutingHelper;
@@ -597,7 +604,6 @@
 
     UeManager::State ueManagerState = ueManager->GetState();
     NS_TEST_ASSERT_MSG_EQ(ueManagerState, UeManager::CONNECTED_NORMALLY, "Wrong UeManager state!");
-    NS_ASSERT_MSG(ueManagerState == UeManager::CONNECTED_NORMALLY, "Wrong UeManager state!");
 
     uint16_t ueCellId = ueRrc->GetCellId();
     uint16_t enbCellId = enbLteDevice->GetCellId();
